﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Faktorial
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private long Faktorial (int cislo)
        {
            long f = 1;
            for (int i = 2; i <= cislo; i++) 
            {
                f = f * i;
            }

            return f;
        }

        private void BtnFor_Click(object sender, RoutedEventArgs e)
        {
            int n = int.Parse(TxtCislo.Text);

            //vypocet
            TxtFaktorial.Text = Faktorial(n).ToString();
        }

        private void BtnWhile_Click(object sender, RoutedEventArgs e)
        {
            /* Deklarace: 'i' ... čítač (aktuální číslo v součinu) - inicializace; 
             * 'f' ... hodnota faktoriálu - inicializace */
            int i = 1;
            long f = 1;

            // Načtení čísla pro výpočet faktoriálu a jeho konverze na číslo
            int.TryParse(TxtCislo.Text, out int n);

            // Opakuj, pokud je čítač menší, nebo roven číslu pro výpočet faktoriálu
            while (i <= n)
            {
                // Výpočet faktoriálu
                f = f * i;

                // Inkrementace čítače
                i++;
            }

            // Zformátovaný výpis vypočteného faktoriálu (konverze na text)
            this.TxtFaktorial.Text = f.ToString("N0");
        }

        private void BtnDoWhile_Click(object sender, RoutedEventArgs e)
        {
            /* Deklarace: 'i' ... čítač (aktuální číslo v součinu) - inicializace; 
             * 'f' ... hodnota faktoriálu - inicializace */
            int i = 1;
            long f = 1;

            // Načtení čísla pro výpočet faktoriálu a jeho konverze na číslo
            int.TryParse(TxtCislo.Text, out int n);

            do
            {
                // Výpočet faktoriálu
                f = f * i;

                // Inkrementace čítače
                i++;
            }
            // Opakuj, dokud je čítač menší, nebo roven číslu pro výpočet faktoriálu
            while (i <= n);

            // Zformátovaný výpis vypočteného faktoriálu (konverze na text)
            this.TxtFaktorial.Text = f.ToString("N0");
        }
    }
}
